---
title: ArrayBuffer
slug: Web/JavaScript/Reference/Global_Objects/ArrayBuffer
tags:
  - ArrayBuffer
  - Class
  - JavaScript
  - Reference
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>ArrayBuffer</code></strong> object is used to represent a generic, fixed-length raw binary data buffer.</p>

<p>It is an array of bytes, often referred to in other languages as a "byte array".You cannot directly manipulate the contents of an <code>ArrayBuffer</code>; instead, you create one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray">typed array objects</a> or a {{jsxref("DataView")}} object which represents the buffer in a specific format, and use that to read and write the contents of the buffer.</p>

<p>The <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer/ArrayBuffer">ArrayBuffer()</a></code> constructor creates a new <code>ArrayBuffer</code> of the given length in bytes. You can also get an array buffer from existing data, for example <a href="/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding#Appendix_to_Solution_1_Decode_a_Base64_string_to_Uint8Array_or_ArrayBuffer">from a Base64 string</a> or <a href="/en-US/docs/Web/API/FileReader/readAsArrayBuffer">from a local file</a>.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{jsxref("ArrayBuffer.ArrayBuffer", "ArrayBuffer()")}}</dt>
 <dd>Creates a new <code>ArrayBuffer</code> object.</dd>
</dl>

<h2 id="Static_properties">Static properties</h2>

<dl>
 <dt>{{jsxref("ArrayBuffer.@@species", "get ArrayBuffer[@@species]")}}</dt>
 <dd>The constructor function that is used to create derived objects.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{jsxref("ArrayBuffer.isView", "ArrayBuffer.isView(<var>arg</var>)")}}</dt>
 <dd>Returns <code>true</code> if <code><var>arg</var></code> is one of the ArrayBuffer views, such as <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray">typed array objects</a> or a {{jsxref("DataView")}}. Returns <code>false</code> otherwise.</dd>
</dl>

<h2 id="Instance_properties">Instance properties</h2>

<dl>
 <dt>{{jsxref("ArrayBuffer.prototype.byteLength")}}</dt>
 <dd>The read-only size, in bytes, of the <code>ArrayBuffer</code>. This is established when the array is constructed and cannot be changed.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{jsxref("ArrayBuffer.prototype.slice()")}}</dt>
 <dd>Returns a new <code>ArrayBuffer</code> whose contents are a copy of this <code>ArrayBuffer</code>'s bytes from <code><var>begin</var></code> (inclusive) up to <code><var>end</var></code> (exclusive). If either <code><var>begin</var></code> or <code><var>end</var></code> is negative, it refers to an index from the end of the array, as opposed to from the beginning.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_an_ArrayBuffer">Creating an ArrayBuffer</h3>

<p>In this example, we create a 8-byte buffer with a {{jsxref("Int32Array")}} view referring to the buffer:</p>

<pre class="brush: js">const buffer = new ArrayBuffer(8);
const view = new Int32Array(buffer);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-arraybuffer-objects', 'ArrayBuffer')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.ArrayBuffer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">JavaScript typed arrays</a></li>
 <li>{{jsxref("SharedArrayBuffer")}}</li>
</ul>
